您的位置:首页 > 其它

HDU 1081 To The Max

2013-11-13 21:56 246 查看
题目链接 HDU 1081

To The Max

Time Limit: 2000/1000 MS (Java/Others) Memory Limit: 65536/32768 K (Java/Others)

Total Submission(s): 6887 Accepted Submission(s): 3311

[align=left]Problem Description[/align]
Given a two-dimensional array of positive and negative integers, a sub-rectangle is any contiguous sub-array of size 1 x 1 or greater located within the whole array. The sum of a rectangle is the sum of all the elements in that rectangle.
In this problem the sub-rectangle with the largest sum is referred to as the maximal sub-rectangle.

As an example, the maximal sub-rectangle of the array:

0 -2 -7 0

9 2 -6 2

-4 1 -4 1

-1 8 0 -2

is in the lower left corner:

9 2

-4 1

-1 8

and has a sum of 15.

[align=left]Input[/align]
The input consists of an N x N array of integers. The input begins with a single positive integer N on a line by itself, indicating the size of the square two-dimensional array. This is followed by N 2 integers separated by whitespace
(spaces and newlines). These are the N 2 integers of the array, presented in row-major order. That is, all numbers in the first row, left to right, then all numbers in the second row, left to right, etc. N may be as large as 100. The numbers in the array will
be in the range [-127,127].

[align=left]Output[/align]
Output the sum of the maximal sub-rectangle.

[align=left]Sample Input[/align]

4
0 -2 -7 0 9 2 -6 2
-4 1 -4 1 -1
8 0 -2


[align=left]Sample Output[/align]

15


[align=left]Source[/align]
Greater New York 2001

[align=left]Recommend[/align]
We have carefully selected several similar problems for you: 1024 1025 1080 1078 1074

//------------------------------------------------------------------------------------------------------------------------------
//------------------------------------------------------------------------------------------------------------------------------

想了好久都没想出来,最后还是看了别人的思路,自己动手实现了一下才AC了。

求最大子串和,将一个二维的问题转化成多个一维的最大子串和问题进行求解

大致转换思路是 给定一个 i 为起始行,j 为结束行,将每一列的元素从 i 行到 j 行累加起来作为一个元素,组成一个长度为n的数组,既可将一个 i 到 j 行的二维数组压缩为一维,求解这个一维数组的最大子串和,循环每一个可能的 i 跟 j ,得到的最大的那个最大子串和即为所求值。

至于一维的最大子串和求解,最大子串和必定以数组中某个元素为结尾,可用dp[i]表示以元素a[i]为结尾的所有子串的最大和,对于dp[i]这个状态,可有两种状态推得,因为dp[i]中必然要含有a[i]这个元素,所以 dp[i] = max ( dp[i-1]+a[i] , a[i] ) ,这个就是状态转移方程,所以找出dp
中最大的值就是该数组的最大子串和。

具体见以下代码的实现

#include<iostream>
#include<stdio.h>
using namespace std;

int a[105][105] , c[105][105][105];		// a为所给元素  c[i][j]
表示对于一个 i j 压缩得的长度为n的数组
int dp[105][105][105];

int max(const int& a , const int& b){
return a>b?a:b;
}

int main(){
int n , i , j , k , l ;
int MAX;
while( scanf( "%d" , &n ) != EOF ){
for( i = 0 ; i < n ; ++i )
for( j = 0 ; j < n ; ++j )
scanf( "%d" , &a[i][j] );
memset( c , 0 , sizeof(c) );
memset( dp , 0 , sizeof(dp) );
MAX = -99999999;							// 对于MAX的初始化不能用0,因为最大子串和也可能是为负
for( i = 0 ; i < n ; ++i ){					// 起始行
for( j = i ; j < n ; ++j ){				// 结束行
for( k = 0 ; k < n ; ++k ){			// 循环所有列
for( l = i ; l <= j ; ++l ) c[i][j][k] += a[l][k] ;			// 计算每一列的和
dp[i][j][k] = max(dp[i][j][k-1]+c[i][j][k],c[i][j][k]);		// 求该i j 对应的压缩数组的最大子串和
if( dp[i][j][k] > MAX ) MAX = dp[i][j][k];
}
}
}
printf( "%d\n" , MAX );
}
return 0;
}
内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息
标签: